using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Web.Script.Serialization;
using System.Collections.Generic;

namespace Jeffz
{
	/// <summary>
	/// Summary description for BoyConverter
	/// </summary>
	public class BoyConverter : JavaScriptConverter
	{
		public override IEnumerable<Type> SupportedTypes
		{
			get
			{
				yield return typeof(Boy);
			}
		}

		public override IDictionary<string, object> Serialize(object obj, JavaScriptSerializer serializer)
		{
			IDictionary<string, object> result = new Dictionary<string, object>();
			
			Boy boy = (Boy)obj;
			result["Name"] = boy.Name;

			// GirlFriend
			if (boy.GirlFriend != null)
			{
				// ժѭ
				boy.GirlFriend.BoyFriend = null;
				result["GirlFriend"] = boy.GirlFriend;

				// ڿͻٽ
				result["__getRealObject"] =
					"function(o) { o.GirlFriend.BoyFriend = o; return o; }";
			}

			return result;
		}

		public override object Deserialize(IDictionary<string, object> dictionary, Type type, JavaScriptSerializer serializer)
		{
			Boy boy = new Boy();
			boy.Name = dictionary["Name"].ToString();

			if (dictionary.ContainsKey("GirlFriend"))
			{
				boy.GirlFriend = serializer.ConvertToType<Girl>(dictionary["GirlFriend"]);
				boy.GirlFriend.BoyFriend = boy;
			}

			return boy;
		}
	}

	public class Boy
	{
		public string Name;

		public Girl GirlFriend;
	}

	public class Girl
	{
		public string Name;

		public Boy BoyFriend;
	}

}